/* ********
   eNX`@C֐@@i쐬ҁF{j

   Qly[W
   Texture Analysis and Synthesis 
   http://graphics.stanford.edu/projects/texture/

   ̃y[WeNX`摜łD
   Texture Synthesis Examples 
   http://graphics.stanford.edu/projects/texture/demo/

   ******** */

/* ========
   wb_t@C */

#include <stdio.h>
// #include <math.h>
// #include <stdlib.h>
#include <time.h>
#include <opencv2/opencv.hpp>
#include "ts_texsyn.h"

/* ========
   }N */


/* ========
   O[oϐ */

// **** eNX`̃tH_
char TS_folder[] = "./textures/";

// **** ߗ׉fQineighborj̑傫
//   nbr >= 1
// ߗ׉fQ̈ӂ 2 * nbr + 1 ƂȂ
int TS_nbr = 3;

// **** ̓eNX`
// t@C
char TS_infile[] = "texture_o_icon.jpg";
// 󂩂ǂ
//   0 : łȂ
//   1 : ł
int TS_in_cyc = 0;
// 𑜓x
int TS_in_x;
int TS_in_y;

// **** o̓eNX`
// t@C
char TS_outfile[] = "texture_o_icon_out.jpg";
// ̂߂̗̎
unsigned int TS_out_seed = 1; 
// 𑜓x
int TS_out_x = 100;
int TS_out_y = 100;

/* ========
   ֐錾 */


/* ========
   ֐ */

/* --------
   C֐
 */
int main( void )
{
    // ̓eNX`
    unsigned char intex[TS_IN_YMAX][TS_IN_XMAX][3];
    cv::Mat intex_cv;   // OpenCV
    // o̓eNX`
    unsigned char outtex[TS_OUT_YMAX][TS_OUT_XMAX][3];
    cv::Mat outtex_cv;  // OpenCV
    // tH_{t@C
    char file[512];

    // ++++ vZԂ̌v
    clock_t time_start, time_end;
    double  time_sec;
    int     time_m;
    double  time_s;

    /* ========
        */

    /* ++++ vZԂ̌vJn */
    printf( "main() ----> start\n" );
    time_start = clock();
 
    /* ========
       ̓eNX`̓ */

    // t@C̓́C\
    strcpy_s( file, sizeof( file ), TS_folder );
    strcat_s( file, sizeof( file ), TS_infile );
    intex_cv = cv::imread( file );
    TS_in_x = intex_cv.cols;
    TS_in_y = intex_cv.rows;
    cv::namedWindow( "input", cv::WINDOW_AUTOSIZE );
    cv::imshow( "input", intex_cv );

    /* ++++ print */
    printf( "main() : TS_infile >> %s\n", TS_infile );
    printf( "intex_cv.cols, rows = %d, %d\n", intex_cv.cols, intex_cv.rows );

    // zւ̃Rs[
    for( int y = 0; y < TS_in_y; y++ ) {
        for( int x = 0; x < TS_in_x; x++ ) {
            for( int c = 0; c < 3; c++ ) {
                intex[y][x][c] = intex_cv.at<cv::Vec3b>( y, x )[c];
            }
        }
    }

    /* ========
       o̓eNX`̍ */

    /* JԂRs[
    for( int y = 0; y < TS_out_y; y++ ) {
        for( int x = 0; x < TS_out_x; x++ ) {
            for( int c = 0; c < 3; c++ ) {
                outtex[y][x][c] = intex[y%TS_in_y][x%TS_in_x][c];
            }
        }
    } */

    /* STASY */
    if( ts_full_search( 
            TS_nbr, 
            TS_in_cyc, TS_in_x, TS_in_y, intex, 
            TS_out_seed, TS_out_x, TS_out_y, outtex ) != 0 ) {
        printf( "err : main() -> ts_full_search()\n" );
        return( 1 ); // ُI
    }

    /* ========
       o̓eNX`̏o */

    // ̈m
    outtex_cv = cv::Mat( TS_out_y, TS_out_x, CV_8UC3 );

    // z񂩂̃Rs[
    for( int y = 0; y < TS_out_y; y++ ) {
        for( int x = 0; x < TS_out_x; x++ ) {
            for( int c = 0; c < 3; c++ ) {
                outtex_cv.at<cv::Vec3b>( y, x )[c] = outtex[y][x][c];
            }
        }
    }

    // t@Cւ̏óC\
    strcpy_s( file, sizeof( file ), TS_folder );
    strcat_s( file, sizeof( file ), TS_outfile );
    cv::imwrite( file, outtex_cv );
    cv::namedWindow( "output", cv::WINDOW_AUTOSIZE );
	cv::imshow( "output", outtex_cv );

    /* ++++ print */
    printf( "main() : TS_outfile >> %s\n", TS_outfile );
    printf( "outtex_cv.cols, rows = %d, %d\n", outtex_cv.cols, outtex_cv.rows );

    /* ========
       I */

    /* ++++ vZԂ̌vI */
    time_end = clock();
    time_sec = ( double )( time_end - time_start ) / ( double )CLOCKS_PER_SEC;
    time_m = ( int )( time_sec / 60.0 );
    time_s = time_sec - ( double )time_m * 60.0;
    printf( "main() : time >> %lf sec. = %d min. %lf sec.\n", time_sec, time_m, time_s );
    printf( "main() <---- end\n" );

    // L[͑҂
    cv::waitKey( 0 );

    // I
    return( 0 );

}

// ==== EOF
